/**
 **   ͻ
 **      Accele- Press Any Key 1.0       from Dave Smith
 **   ͼ
 **
 **  This program is guaranteed to do absolutely NOTHING !  It was written
 **  just for fun in September 1991, and can be freely copied, given away,
 **  and used in your own programs.
 **
 **  For the beginners, let us review our low-level INT 10H calls:
 **
 **  r.h.ch=0;           CH is the top side of our window
 **  r.h.cl=0;           CL is the left side of our window
 **  r.h.dh=24;          DH is the bottom side of our window
 **  r.h.dl=79;          DL is the right side of our window
 **  r.h.bh=15;          BH = the color for the scrolled part
 **  r.h.al=1;           AL is how many lines to scroll
 **  r.h.ah=7;           AH is scroll up, or down  (6 or 7)
 **  int86(0x10,&r,&r);  call BIOS with INT 10H (must have our UNION REGS R;)
 **
 **  delay(70);          delay, so that it doesn't scroll so damn fast
 **                      that we cannot see it !
 **
 **  So that's all... Enjoy the code, and any questions, comments, write
 **                   me:
 **
 **                ͸
 **                      Dave Smith      
 **                    CIS 71441,2723    
 **                ;
 **/

#include <io.h>
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>

                             /* ScreenBuffer saves and restores the screen */
void ScreenBuffer(int Mode);
                             /* Box_Shade creates a box with shading */

void box_shade(int ax, int ay, int bx, int by, int linecolor, int backcolor);

extern BEGCLEAR(void);       /* These are simple ASM routines that */
extern BEGCLR2(void);        /* clear the screen very fast with a  */
extern BEGCLR3(void);        /* variety of colors and patterns.    */
extern BEGCLR4(void);
extern BEGCLR5(void);
extern BEGBOMB(void);

void main(int argc, char *argv[])
{

union REGS r;       /* Set up our own low level calls */
int comline;        /* What choice comes from command line */
int x;              /* X and Y are our counter integers */
int y;
int temp;           /* Another counter variable */
int lines=15;       /* The chosen line color from the command line */
int inbox=1;        /* The color inside the textbox chosen from the command line */

disable();          /* Must disable the interrupts so that the Timer will not */
                    /* interfere with our graphics and sounds */

ScreenBuffer(0);    /* Save the Screen */

if(strstr(argv[1],"?")||argc==1){
  printf("\n Accele- PRESS ANY KEY  from Dave Smith");
  printf("\n\n    Usage: ACP [option] [boxline color] [inside box color]");
  printf("\n\n   =========== OPTIONS: ==========");
  printf("\n\n         1.  Textured Frame     10. Flash");
  printf("\n         2.  Shove Down         11. Thick Lines");
  printf("\n         3.  Squish             12. Thin Lines");
  printf("\n         4.  Close Frame        13. Zoom Out");
  printf("\n         5.  Fade Out           14. Stars");
  printf("\n         6.  Shake              15. Frame Open");
  printf("\n         7.  Whappo             16. Off and On");
  printf("\n         8.  Zapped             17. Four Windows");
  printf("\n         9.  Color Dump         18. Sudden Noise\n\n");
  exit(0);
  }
                           /* Get what we need from the command line, and
                           ** set our defaults.
                           */

comline=atoi(argv[1]);
  lines=15;   inbox=1;
if(argv[2]) lines=atoi(argv[2]);
if(argv[3]) inbox=atoi(argv[3]);

switch(comline){

          /**  "Textured Frame" just clears the screen nicely,
           **  then puts our frame on the screen.
           **/

case 1: BEGCLEAR();
        box_shade(22,9,56,15,lines,inbox);
        textcolor(15);
        textbackground(inbox);
        gotoxy(25,12);
        cprintf("Press Any Key to Continue ...");
        break;

          /**  "ShoveDown" uses service 7 to scroll screen down
           **  26 times for the appearance of being shoved.
           **/

case 2: for(y=1;y<26;y++)
           {
            r.h.ch=0;
            r.h.cl=0;
            r.h.dh=24;
            r.h.dl=79;
            r.h.bh=15;
            r.h.al=1;
            r.h.ah=7;
            int86(0x10,&r,&r);
            delay(70);
           }
        textcolor(14+128);
        textbackground(0);
        gotoxy(24,11);
        cprintf("Press Any Key To Continue ...");
        break;

          /**  "Squish" splits the screen in half, then scrolls both
           **  sides together.
           **/

case 3: for(y=1;y<14;y++)
           {
            r.h.ch=0;
            r.h.cl=0;
            r.h.dh=12;
            r.h.dl=79;
            r.h.bh=15;
            r.h.al=1;
            r.h.ah=7;
            int86(0x10,&r,&r);
            r.h.ch=12;
            r.h.cl=0;
            r.h.dh=24;
            r.h.dl=79;
            r.h.bh=15;
            r.h.al=1;
            r.h.ah=6;
            int86(0x10,&r,&r);
            delay(70);
           }
        textcolor(2);
        textbackground(0);
        gotoxy(24,11);
        cprintf("Press Any Key To Continue ...");
        break;

          /**  "Close Frame" scrolls each side of the screen toward
           **  each other, thus appearing to 'close'.
           **/

case 4:
     for(y=0;y<40;y++){
        r.h.ch=0;
        r.h.cl=y;
        r.h.dh=24;
        r.h.dl=y;
        r.h.bh=15;
        r.h.al=25;
        r.h.ah=7;
        int86(0x10,&r,&r);

        r.h.ch=0;
        r.h.cl=79-y;
        r.h.dh=24;
        r.h.dl=79-y;
        r.h.bh=15;
        r.h.al=25;
        r.h.ah=7;
        int86(0x10,&r,&r);
        delay(17);
                       }
      box_shade(22,9,56,15,lines,inbox);
      textcolor(15);
      textbackground(inbox);
      gotoxy(25,12);
      cprintf("Press Any Key to Continue ...");
      break;

          /**  "Fade" just puts dots on the screen, then clears it.
           **/

case 5:
      textbackground(0);
      randomize();
    for(temp=1;temp<3000;temp++)
      {
      y=random(24)+1;
      x=random(80)+1;
      gotoxy(x,y);
      cprintf(" ");
      }
      clrscr();
      box_shade(22,9,56,15,lines,inbox);
      textcolor(15);
      textbackground(inbox);
      gotoxy(25,12);
      cprintf("Press Any Key to Continue ...");
      break;

          /**  "Shake" scrolls the screen up, then down 14 times, then
           **  restores the screen and puts our box on.
           **/

case 6: for(y=1;y<15;y++){
           r.h.ch=0;
           r.h.cl=0;
           r.h.dh=24;
           r.h.dl=79;
           r.h.bh=15;
           r.h.al=1;
           r.h.ah=6;
           int86(0x10,&r,&r);

           delay(90);
           r.h.ch=0;
           r.h.cl=0;
           r.h.dh=24;
           r.h.dl=79;
           r.h.bh=15;
           r.h.al=1;
           r.h.ah=7;
           int86(0x10,&r,&r);

           delay(90);
                        }
           ScreenBuffer(1);

           box_shade(22,9,56,15,lines,inbox);
           textcolor(15);
           textbackground(inbox);
           gotoxy(25,12);
           cprintf("Press Any Key to Continue ...");
           break;

          /**  "Whappo" just does some quick scrolling.
           **/

case 7: for(y=1;y<30;y++){
           r.h.ch=0;
           r.h.cl=0;
           r.h.dh=12;
           r.h.dl=79;
           r.h.bh=15;
           r.h.al=3;
           r.h.ah=6;
           int86(0x10,&r,&r);
           delay(20);
           r.h.ch=12;
           r.h.cl=0;
           r.h.dh=24;
           r.h.dl=79;
           r.h.bh=15;
           r.h.al=3;
           r.h.ah=7;
           int86(0x10,&r,&r);
           delay(20);
           ScreenBuffer(1);
                        }

           ScreenBuffer(1);
           box_shade(22,9,56,15,lines,inbox);
           textcolor(15);
           textbackground(inbox);
           gotoxy(25,12);
           cprintf("Press Any Key to Continue ...");
           break;

          /**  "Zapped" squishes the screen from a vertical and
           **  horizontal place.
           **/

case 8: for(y=0;y<40;y++){
           r.h.ch=0;
           r.h.cl=y;
           r.h.dh=24;
           r.h.dl=y;
           r.h.bh=15;
           r.h.al=25;
           r.h.ah=7;
           int86(0x10,&r,&r);

           r.h.ch=0;
           r.h.cl=79-y;
           r.h.dh=24;
           r.h.dl=79-y;
           r.h.bh=15;
           r.h.al=25;
           r.h.ah=7;
           int86(0x10,&r,&r);

           delay(17);

           gotoxy(1,y+1);

           clreol();

           gotoxy(1,24-y);

           clreol();
                          }

         box_shade(22,9,56,15,lines,inbox);
         textcolor(15);
         textbackground(inbox);
         gotoxy(25,12);
         cprintf("Press Any Key to Continue ...");
         break;

          /**  "ColorDrop" just clears the screen, then drops our message
           **  and erases the extras from top and bottom.
           **/

case 9: textbackground(0);
        clrscr();

        for(y=1;y<25;y++)
          {
           delay(70);
           textcolor(y);
           gotoxy(26,y);
           cprintf("Press Any Key To Continue ...");
          }

        for(y=1;y<12;y++)
          {
           delay(80);
           gotoxy(1,y);
           clreol();
           delay(80);
           gotoxy(1,25-y);
           clreol();
           gotoxy(1,12);
           clreol();
          }

       break;

          /**  "Flash" places a lot of different textures and colors on the
           **  screen, then prints our box and message.
           **/

case 10: BEGCLR2();

         box_shade(22,9,56,15,lines,inbox);
         textcolor(15);
         textbackground(inbox);
         gotoxy(25,12);
         cprintf("Press Any Key to Continue ...");

       delay(80);

         BEGCLR3();

         box_shade(22,9,56,15,lines,inbox);
         textcolor(15);
         textbackground(inbox);
         gotoxy(25,12);
         cprintf("Press Any Key to Continue ...");

       delay(90);
         BEGCLR2();
       delay(70);
         BEGCLR3();
       delay(70);
         BEGCLR2();
       delay(80);
         BEGCLR3();
       delay(80);
         BEGCLR2();
       delay(80);
         BEGCLR3();
       delay(80);
         BEGCLR2();
       delay(90);
         BEGCLR3();
       delay(70);

         box_shade(22,9,56,15,lines,inbox);
         textcolor(15);
         textbackground(inbox);
         gotoxy(25,12);
         cprintf("Press Any Key to Continue ...");
         break;

          /**  "Thick Lines" throws our ASM screen on, then the box
           **/

case 11: BEGCLR4();

         box_shade(22,9,56,15,lines,inbox);
         textcolor(15);
         textbackground(inbox);
         gotoxy(25,12);
         cprintf("Press Any Key to Continue ...");
         break;

          /**  "Thin Lines" is similar to the above
           **/

case 12: BEGCLR5();

         box_shade(22,9,56,15,lines,inbox);
         textcolor(15);
         textbackground(inbox);
         gotoxy(25,12);
         cprintf("Press Any Key to Continue ...");
         break;

         /**  "Zoom Out" places larger and larger boxes on the screen.
          **/

case 13: box_shade(2,21,5,23,2,15);
         box_shade(4,19,14,22,2,15);
         box_shade(9,16,21,21,2,15);
         box_shade(15,14,39,18,2,15);
         box_shade(19,10,48,16,2,15);
         box_shade(22,9,56,15,2,15);
         textcolor(0);
         textbackground(7);
         gotoxy(25,12);
         cprintf("Press Any Key to Continue ...");
         break;

          /**  "Stars" puts a Star Trek effect on the screen around
           **  our message.
           **/

case 14: textcolor(14);
         textbackground(0);

         clrscr();
         gotoxy(21,12);
         cprintf("  Press Any Key to Continue ...  ");

         x=10;
         y=60;

         textcolor(4);

         while(!kbhit())
           {
            gotoxy(x,9);   cprintf("*");
            gotoxy(x,15);  cprintf("*");
            gotoxy(y,9);   cprintf("*");
            gotoxy(y,15);  cprintf("*");
            delay(40);
            gotoxy(x,9);   cprintf(" ");
            gotoxy(x,15);  cprintf(" ");
            gotoxy(y,9);   cprintf(" ");
            gotoxy(y,15);  cprintf(" ");

            x++;
            y--;

             if(x>36){ x=10; y=60; }
           }

         break;

          /**  "Frame Open" is "Frame Close" in reverse.
           **/

case 15:    x=41;

         for(y=40;y>0;y--){
            r.h.ch=0;
            r.h.cl=y;
            r.h.dh=24;
            r.h.dl=y;
            r.h.bh=15;
            r.h.al=25;
            r.h.ah=7;
            int86(0x10,&r,&r);

            r.h.ch=0;
            r.h.cl=x;
            r.h.dh=24;
            r.h.dl=x;
            r.h.bh=15;
            r.h.al=25;
            r.h.ah=7;
            int86(0x10,&r,&r);

            delay(17);        x++;
                           }

          box_shade(22,9,56,15,lines,inbox);
          textcolor(15);
          textbackground(inbox);
          gotoxy(25,12);
          cprintf("Press Any Key to Continue ...");
          break;

          /**  "Off and On" just flashes the box on and off.
           **/

case 16: for(temp=1;temp<8;temp++){

           textbackground(0);
           clrscr();
           box_shade(22,9,56,15,lines,inbox);
           textcolor(15);
           textbackground(inbox);
           gotoxy(25,12);
           cprintf("Press Any Key to Continue ...");
           delay(70);
           }

         box_shade(22,9,56,15,lines,inbox);
         textcolor(15);
         textbackground(inbox);
         gotoxy(25,12);
         cprintf("Press Any Key to Continue ...");
         break;

          /**  "Four Windows"... here goes our screen split/scroll effects
           **  again !  This time, we do four windows.
           **/

case 17: for(y=1;y<15;y++){
         r.h.ch=0;
         r.h.cl=0;
         r.h.dh=11;
         r.h.dl=39;
         r.h.bh=15;
         r.h.al=1;
         r.h.ah=6;
         int86(0x10,&r,&r);

         r.h.ch=0;
         r.h.cl=40;
         r.h.dh=11;
         r.h.dl=79;
         r.h.bh=15;
         r.h.al=1;
         r.h.ah=7;
         int86(0x10,&r,&r);

         r.h.ch=12;
         r.h.cl=0;
         r.h.dh=24;
         r.h.dl=39;
         r.h.bh=15;
         r.h.al=1;
         r.h.ah=6;
         int86(0x10,&r,&r);

         r.h.ch=12;
         r.h.cl=40;
         r.h.dh=24;
         r.h.dl=79;
         r.h.bh=15;
         r.h.al=1;
         r.h.ah=7;
         int86(0x10,&r,&r);

         delay(60);
         }

         box_shade(22,9,56,15,lines,inbox);
         textcolor(15);
         textbackground(inbox);
         gotoxy(25,12);
         cprintf("Press Any Key To Continue ...");
         break;

          /***    "Sudden" uses our ASM calls.    ***/

case 18: BEGBOMB();
         break;
                            }

getch();

exit(0);  /* We're Out of here ! */
}

      /**  Box_Shade clears an area of the screen in a specific color,
       **  then places a box there... Then shade it nicely
       **/

void box_shade(int ax, int ay, int bx, int by, int linecolor, int backcolor)
{

int x,y;

textbackground(backcolor);
textcolor(linecolor);

for(y=ay; y<by+1; y++)
   for(x=ax; x<bx+1; x++){ gotoxy(x,y); cprintf(" "); }

gotoxy(ax,by);
cprintf("");
gotoxy(bx,ay);
cprintf("");
gotoxy(ax,ay);
cprintf("");
gotoxy(bx,by);
cprintf("");

for(y=ax+1;y<bx;y++){
    gotoxy(y,ay);
    cprintf("");
    gotoxy(y,by);
    cprintf("");
    }
for(y=ay+1;y<by;y++){
    gotoxy(ax,y);
    cprintf("");
    gotoxy(bx,y);
    cprintf("");
    }
textcolor(0);
for(y=ax+1;y<=bx+1;y++){
    gotoxy(y,by+1);
    cprintf("");
    }
for(y=ay+1;y<=by+1;y++){
    gotoxy(bx+1,y);
    cprintf("");
    }
}
        /**   ScreenBuffer checks the current video availability,
         **   then saves the screen in an array.
         **/

void ScreenBuffer(int Mode)
{
int i;

    static int far *VideoRam;
    static int ScreenStorage[2000];
    union REGS Regin;

    if( VideoRam==NULL)
   {
     Regin.h.ah=0x0F;
      int86(0x10, &Regin, &Regin);
      if(Regin.h.al==7) /* Mono video card */
         VideoRam=(int far *)0xB000000;
      else
         VideoRam=(int far *)0xB8000000;
   }
   if(Mode==0)
      for(i=0;i<2000;i++)
         ScreenStorage[i]=*(VideoRam+i);
   else
      for(i=0;i<2000;i++)
         *(VideoRam+i)=ScreenStorage[i];
}
